#ifdef GL_ES
	precision mediump float;
#endif

uniform sampler2D u_texture0;
uniform sampler2D u_causticTexture;
uniform float u_frameTime;

#ifdef UV2
	uniform sampler2D u_texture1;
#endif

varying vec2	v_texCoord0;
varying vec2	v_causticCoord0;
varying vec2	v_causticCoord1;
varying float	v_NdotL;
varying float	v_fog;
varying vec3	v_lightDiffuse;

#ifdef UV2
	varying vec2	v_texCoord1;
#endif

#ifdef VertexColor
	varying vec3	v_color;
#endif

vec3 fogColor = vec3(0.063, 0.204, 0.365);

void main(){
	vec4 color = texture2D(u_texture0, mod(v_texCoord0, 1.0));
	
	#ifdef UV2
		vec4 maskColor = texture2D(u_texture1, mod(v_texCoord1, 1.0));
		color = color*maskColor;
	#endif
	
	vec4 causticColor1 = texture2D(u_causticTexture, mod(v_causticCoord0, 1.0));
	vec4 causticColor2 = texture2D(u_causticTexture, mod(v_causticCoord1, 1.0));
	
	float causticIntensity = dot(causticColor2, causticColor2) * dot(causticColor1, causticColor1)*0.3;
	//float causticIntensity = max(causticColor2.r, max(causticColor2.g, causticColor2.b)) *max(causticColor1.r, max(causticColor1.g, causticColor1.b));
	vec4 causticColor = (causticColor1+causticColor2*0.3) * v_NdotL * causticIntensity;
	
	#ifdef VertexColor
//		vec3 combined	= mix(color.rgb*v_color, causticColor.rgb,0.2);
//		vec3 combined	= color.rgb * v_color + causticColor.rgb * 0.2;
		vec3 combined	= color.rgb * v_color * (causticColor.rgb * 0.8 + 1.0) + causticColor.rgb * 0.1;
	#else
//		vec3 combined	= mix(color.rgb, causticColor.rgb, 0.2);
//		vec3 combined	= color.rgb + causticColor.rgb * 0.2;
		vec3 combined	= color.rgb * (causticColor.rgb * 0.8 + 1.0) + causticColor.rgb * 0.1;
	#endif
	
	gl_FragColor = vec4(combined * v_lightDiffuse, color.a);
    
#ifdef Fog
	gl_FragColor.rgb = mix(gl_FragColor.rgb, fogColor, v_fog);
#endif
}